#-*- coding: utf-8 -*-
# 
# PROJET_IMAGE_CHASSIS.py


# Importation des bibliothèques
from struct import pack
from os import chdir
from os import stat

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI STEGANOGRAPHIE\CORRIGE_TRAITEMENT_IMAGES'
chdir(path)

# Définir la liste qui vas contenir l'image
image_totale = []

def calcul_valeur_offset_fichier(X, Y, L, bfOffBits):
    '''
    Script1
    
    Calcul de l'offset de début de codage d'un pixelRVB dans un fichier .bmp
    Entrée :
        X : abscisse du pixel = n°ligne
        Y : ordonnée du pixel = n°colonne
        L : largeur de l'image en pixels
        bfOffBits : champ de l'en tête du fichier indiquant le début de la zone 
        image
    Sortie :
        Offset par rapport au début du fichier .bmp de la description du 
        pixel X,Y
    '''
    # A COMPLETER
    
    
def quatre_octets_vers_integer(liste):
    '''
    A partir de quatre bytes dans une liste fournie en entrée
    la fonction calcule  la valeur entière positive correspondante.
    Les bytes sont dans l'ordre little endian, donc poids faible en 
    liste[0] --- poids fort en liste[3].
    
    Entrée : 
        liste contient quatre octets au format bytes 
    
    Sortie : 
        valeur numérique entière positive
    '''
    valeur_entier =  int.from_bytes(liste[0],'little') + \
                     int.from_bytes(liste[1],'little')*16*16 + \
                     int.from_bytes(liste[2],'little')*16**4  + \
                     int.from_bytes(liste[3],'little')*16**6
    return valeur_entier

def lecture_valeur_pixel(adresse_debut,image_totale):
    '''
    Script3
    
    Les trois octets RVB d'un pixel sont lus dans l'image du fichier
    contenu dans la liste image_totale  à l'adresse adresse_debut.
    Attention dans les fichiers BMP les composantes de couleurs sont
    stockées dans l'ordre B,V,R
    
    Entrée :
        adresse_debut : adresse de la position du premier des trois octets 
        du pixel dans le fichier
        image_totale : liste contenant l'image recopiée à partir du fichier bmp
        
    Sortie :
        Un tuple contenant les trois valeurs dans l'ordre (R,G,B)
    '''
    # A COMPLETER
    
    
    
    
    
    return (R, G, B)

def ecriture_valeur_pixel(adresse_debut,image_totale,R,G,B):
    '''
    Script4
    
    Les trois octets RVB d'un pixel sont écrits dans l'image du fichier
    contenu dans la liste image_totale  à l'adresse adresse_debut.
    Attention dans les fichiers BMP les composantes de couleurs sont
    stockées dans l'ordre B,G,R
    
    Entrée :
        adresse_debut : adresse de la position du premier des trois octets 
        du pixel le fichier
        image_totale : liste contenant l'image recopiée à partir du fichier bmp
        R,V,B : valeurs numériques des trois composantes 0 <= x <= 255
        
    Sortie :
        Aucune, le pixel est modifié dans la liste image_totale
    '''
    # A COMPLETER
    
    
    
                
    return None

## PROGRAMME PRINCIPAL IMAGES
# Ouverture du fichier cible 
image_a_traiter = input("Donner le nom complet du fichier à traiter : ")
if image_a_traiter=='':
    image_a_traiter = "Mire.bmp"
fichier_origine = open(image_a_traiter,"rb")

info_fichier = stat(image_a_traiter)
taille_du_fichier = info_fichier.st_size
print("\nNom du fichier traité : ",image_a_traiter)

# Recopie dans une liste
for i in range(taille_du_fichier):
    image_totale.append(fichier_origine.read(1))

# Fermeture du fichier
fichier_origine.close()


# RECUPERATION DES PARAMETRES
# Remplace le script2
# 

# .Largeur de l'image en pixels
largeur = image_totale[0x12:0x16]
valeur_largeur = quatre_octets_vers_integer(largeur)
print("Largeur de l'image en pixels : ",valeur_largeur)

# .Hauteur de l'image en pixels
hauteur = image_totale[A COMPLETER]
valeur_hauteur = quatre_octets_vers_integer(hauteur)
print("Hauteur de l'image en pixels : ",valeur_hauteur)


# .Offset de la zone image en octets : bfOffBits
offset_image = image_totale[A COMPLETER]
valeur_offset_image = quatre_octets_vers_integer(offset_image)
print("Offset de la zone de définition de l'image : #{:04X}".format(valeur_offset_image))


# TRAITEMENT DE L'IMAGE
# Boucle sur tous les pixels de l'image
for X in range(1,valeur_largeur+1):
    for Y in range(1,valeur_hauteur+1):
        
        # Calcul de l'adresse du pixel 
        adresse_pixel = calcul_valeur_offset_fichier(X, Y, valeur_largeur, valeur_offset_image)
        
        # Récupération de la valeur R G B du pixel avec
        # la fonction lecture_valeur_pixel
        A COMPLETER = lecture_valeur_pixel(adresse_pixel, image_totale)
        
        # Modification du pixel voir script6, script7, script8
        A COMPLETER
        
        
        # Ecriture du pixel dans la liste contenant l'image complète
        # avec les nouvelles valeurs new_R, new_V, new_B
        ecriture_valeur_pixel(adresse_pixel,image_totale, new_R, new_V, new_B)




    
# A partir de l'image travaillée en local dans la liste
# on la recopie dans un fichier
fichier_resultat=open("test.bmp","wb")
for byte in image_totale:
    fichier_resultat.write(byte)
fichier_resultat.close()

print("Modification réalisée, le résultat est dans le fichier test.bmp")
